#
# spec file for package ndiswrapper (Version 1.1)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  kernel-source

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gdbm gettext kernel-source libtool perl rpm

Name:         ndiswrapper
Group:        System/Kernel
Autoreqprov:  on
Summary:      Use Microsoft NDIS network drivers for WLAN cards
Version:      1.1
Release:      4.4
Requires:     pciutils
Source0:      %name-%version.tar.bz2
Source1:      Makefile.in
Source2:      README.SUSE
Patch0:       ndiswrapper.diff
URL:          http://ndiswrapper.sourceforge.net
License:      GPL
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
ExclusiveArch: %ix86 x86_64

%description
Some wireless LAN vendors refuse to release hardware specifications or
drivers for their products for operating systems other than Microsoft
Windows. The ndiswrapper project makes it possible to use such hardware
with Linux by means of a loadable kernel module that "wraps around"
NDIS (Windows network driver API) drivers.



Authors:
--------
    Pontus Fuchs <pof@users.sourceforge.net>

%prep
%setup
%patch0 -p1
cp %{SOURCE2} .

%build
make -C utils CFLAGS="$RPM_OPT_FLAGS"
make -C driver hal_exports.h misc_funcs_exports.h ndis_exports.h \
	ntoskernel_exports.h usb_exports.h wrapper_exports.h
%ifarch x86_64
make -C driver CONFIG_X86_64=y x86_64_stubs
%endif

%install
rm -rf %buildroot
install -d -m 755 %buildroot/sbin %buildroot/usr/sbin \
    %buildroot/etc/ndiswrapper
# Userspace stuff
install -m 755 utils/loadndisdriver %buildroot/sbin
install -m 755 utils/ndiswrapper %buildroot/usr/sbin
# Kernel module
mod_dir=%buildroot/usr/src/kernel-modules/%name
install -d -m 755 $mod_dir
cp -r driver/* version $mod_dir/
rm $mod_dir/Makefile
sed -e "s/@DRV_VERSION@/%{version}/" \
	%_sourcedir/Makefile.in > $mod_dir/Makefile
# modprobe settings
install -d -m 755 %buildroot/etc/modprobe.d
# modprobe -m writes to this file:
touch %buildroot/etc/modprobe.d/ndiswrapper
#if [ -d /usr/src/linux ]; then
#    cd $RPM_BUILD_ROOT/usr/src/kernel-modules/%name
#    make -f /usr/src/linux/Makefile.suse modules
#    make -f /usr/src/linux/Makefile.suse clean
#fi

%files
%defattr(-, root, root)
/etc/ndiswrapper
/sbin/loadndisdriver
/usr/sbin/ndiswrapper
%config /etc/modprobe.d/ndiswrapper
%doc README
%doc README.SUSE
%doc INSTALL
%doc AUTHORS
%doc ChangeLog
#=======================================================================
%package -n km_ndiswrapper
Group:        System/Kernel
Summary:      Kernel module sources for the NDIS wrapper

%description -n km_ndiswrapper
Contains the source code for the ndiswrapper kernel module. The binary
kernel packages require this package to include this module in the
resulting binary kernels.



Authors:
--------
    Pontus Fuchs <pof@users.sourceforge.net>


%files -n km_ndiswrapper
%defattr(-, root, root)
/usr/src/kernel-modules

%changelog -n ndiswrapper
* Fri Mar 11 2005 - jg@suse.de
- enabled building on x86_64
* Mon Mar 07 2005 - jg@suse.de
- update to version 1.1, changes:
  * Yet another spinlock (re)implementation. We don't use Linux
  spinlocks to implement Windows spinlocks anymore - ndiswrapper
  implements new spinlock functions that use Windows spinlock
  variables directly.
  * Use kmem_cache pools for MDL (aka NDIS_BUFFER) and NDIS_PACKET
  structures which are allocated often. This should reduce memory
  fragmentation.
  * Use MDL functions when initializing ndis_packet while sending
  packets. This fixes crashes with Fedora kernels (and amd64
  driver at least).
  * Memory leak with 64-bit Broadcom driver fixed
  * Crash when module is removed with Marvell driver fixed
  * In some cases, a Windows driver loads successfully, but
  ndiswrapper concludes otherwise. This is fixed.
* Fri Feb 11 2005 - jg@suse.de
- added missing object file in Makefile
* Mon Feb 07 2005 - jg@suse.de
- update to version 1.1rc1, changes:
  * Don't use spinlocks unless CONFIG_SMP or CONFIG_DEBUG_SPINLOCK
  is enabled.
  * Don't reset Centrino cards during initialization as this seems
  to turns off radio.
  * Set the active/transmit key index as given, instead of assuming
  1 always. This fixes authentication with Cisco routers. This
  should also fix WEP issues when active key used on the router
  is at index > 1.
  * NdisAcquire(Dpr)SpinLock obtains the lock at DISPATCH_LEVEL
  instead of PASSIVE_LEVEL. This fixes PREEMPT and SMP issues
  with some drivers.
  * Issue with Prism54 driver sometimes crashing kernel when
  scanning fixed.
  * WavePlus 1200 chipset supported.
  * Works with some vendor kernels that use different semantcis
  (from vanilla kernels) for PCI/USB register functions.
  * Don't free memory allocated for 'devices' twice (which was
  causing kernel crash) when device registration failed.
  * Don't set infrastructure mode in wpa_associate, which clears
  the keys. With this, WEP should work again with wpa_supplicant.
  * Fix (small) memory leak - free xmit_array when device is removed.
  * Use spinlock when calling any miniport function. This may fix
  some SMP issues.
  * Preliminary support for AMD64 (tested with Broadcom chipset)
  * Dynamic loader support: A driver is loaded only when necessary,
  so even if many drivers are installed or if a driver installs
  many .conf files (e.g., Centrino), only drivers and device
  configurations necessary are loaded.
  * Set RadioState used by Broadcom drivers to 0, instead of 1. This
  turns on radio (although name suggets the other way round).
  * Sends multiple packets (if driver supports it) in each send
  operation for better efficiency
  * Most of the functionality of loader is moved to userspace tool
  loadndisdriver so it is more robust
  * Encryption info is restored during disassociation; this is useful
  if ad-hoc mode is used as psuedo master mode
  * MAC address can be set in .conf files or changed at any
  * Association and disassociation should happen quickly especially
  with wpa_supplicant
* Thu Dec 16 2004 - jg@suse.de
- update to version 0.12, changes:
  * Works with Preempt and SMP kernels.
  * WPA-RADIUS is supported.
  * Compiles with kernels > 2.6.9 and swsuspend2
  * USB cards are reset during initialization; they should work
  without having to reset explicitly
  * Some crashes in USB, especially during initialization, are
  fixed.
  * WEP key setting problems fixed.
  * Check for 4K stack size during compilation and issue warning
  if necessary.
  * Bug fixes
* Fri Oct 22 2004 - jg@suse.de
- update to version 0.11, changes:
  * Compilation issues with USB are fixed
  * WPA issues fixed
  * Older Prism USB devices supported
  * Suspend/resume of devices with no power management (e.g., TI)
  fixed
  * ndiswrapper script has an option "-d" to install drivers for a
  different device (if the chipset is same)
  * ndiswrapper script lists USB devices and reports status of
  drivers with more understandable messages
  * Lots of bug fixes and improvements
- registering all devices with driver name 'ndiswrapper', so ifup
  scripts have the possibility to recognize ndiswrapper
- fixed sysfs links (device/driver links were missing)
* Tue Oct 05 2004 - agruen@suse.de
- Add a README.SUSE.
* Mon Sep 27 2004 - agruen@suse.de
- Update to version 0.10.
* Fri Jun 11 2004 - agruen@suse.de
- Update to version 0.8.
* Mon Mar 29 2004 - agruen@suse.de
- Add missing object file.
* Mon Mar 29 2004 - agruen@suse.de
- Fix a thinko: Exporting the module version works for the test
  build, but doesn't help in the binary kernels.
* Sun Mar 28 2004 - agruen@suse.de
- Update to version 0.6+CVS.
* Tue Mar 09 2004 - agruen@suse.de
- Update to version 0.5 + regparm fix.
* Sat Feb 21 2004 - agruen@suse.de
- CVS update.
* Mon Jan 26 2004 - ro@suse.de
- create directory before use
* Sun Jan 25 2004 - agruen@suse.de
- Remove /etc/modprobe.d from the file list: This is in the
  module-init-tools package now.
* Fri Jan 23 2004 - agruen@suse.de
- Only build on i386 non-SMP kernels.
* Sat Jan 17 2004 - agruen@suse.de
- Skip building the kernel module on SMP systems.
- Add sysconfig settings and SuSEconfig script.
* Tue Jan 13 2004 - agruen@suse.de
- spec file: BuildArch should really be ExclusiveArch.
* Mon Jan 12 2004 - agruen@suse.de
- Fix directory ownership for rpm.
* Mon Jan 12 2004 - agruen@suse.de
- Initial package.
